(*General remark : n p m t = name player(s) map turn*)
open Move


type state_param = JSON of string | TXT of string * string *
                                             (string * string* (Move.pos list)) list * int

exception FatalError of string
(* n'est jamais rattrapé, est lancé lors d'une erreur de protocole*)


(*Initialisation : we extract TXT if state param is TXT
  if state param is JSON, we initialize with dummy values
  and we call open_map*)



(*Donne le charactère en fonction de l'indice de la position dans le chemin*)
let path_char i =
  if i < 26 then
    char_of_int (97 + i)
  else if i < 52 then
    char_of_int (65 + i-26)
  else
    '?'

(*TODO modifiable nb peng per player*)
let default_player = new Player.humanPlayer "" [|(0,0)|]
			 
(*transforms a list of players into an array*)
let array_of_list_players l =
  let a = Array.make (List.length l) default_player in
  let rec browse_list l' i = match l' with
    |[] -> ()
    |x::q -> a.(i) <- x;
	     browse_list q (i+1)
  in
  browse_list l 0;
  a

(*transforms a list of positions into an array*)
let array_of_list_pos l =
  let a = Array.make (List.length l) (0,0) in
  let rec browse_list l' i = match l' with
    |[] -> ()
    |x::q -> a.(i) <- x;
	     browse_list q (i+1)
  in
  browse_list l 0;
  a

    
(*TODO many penguins per player*)
let player_from_txt (p_name, p_type, p_pos) = match p_type with
  |"Humain" -> new Player.humanPlayer p_name (array_of_list_pos p_pos)
  |"IA Standard" -> new Player.iaStandardPlayer p_name (array_of_list_pos p_pos)
  |"IA Facile" -> new Player.iaFacilePlayer p_name (array_of_list_pos p_pos)
  |"IA Aléatoire" -> new Player.iaRandomPlayer p_name (array_of_list_pos p_pos)
  |_ -> failwith ("Unknown player type for player "^p_name)







class game_state (param : state_param) =
  (*initialization : we extract name, players,map, turn  and 
   *challenge from the input*)
  let (a_name,a_players_lst,a_map,a_turn,a_challenge) = match param with
    |JSON fjson_name -> Json_parsing.parse_main_json fjson_name
    |TXT(map_file,n,p,t) ->
      let map_, _ = IO.parse_map map_file in
      let players_ = List.map player_from_txt p in
      (n,players_ ,map_,t,[]) in (* there is no challenge for txt*)
  let a_players = array_of_list_players a_players_lst in

  object (self)


    method name = a_name
    method challenges = a_challenge
    val players =  a_players
    val map =  a_map
    val mutable turn =  a_turn

    method get_cell l c =
      if l >=0 && c >= 0&& l < Array.length map &&
           c <  Array.length map.(0) then
        map.(l).(c)
      else
        WATER

    method dimensions () = (Array.length map , Array.length map.(0))

    method get_map () = Array.map Array.copy map
    method get_players () = players
    method set_turn n = turn <- n
    method get_turn () = turn
    method next_turn () = turn <- (turn + 1) mod (Array.length players)



    method nb_peng_by_player = 4


    (* This method returns the modification of the positon p generated by a 
     * displacement in direction d.*)
    method private move p d =
      let (pl,pc) = p in (*l et c veulent dire respectivement ligne et colonne*)
      let line_type = pl mod 2 in
      match d with
      |Move.E  -> (pl,pc+1)
      |Move.NE -> (pl-1,pc+1-line_type)
      |Move.SE -> (pl+1,pc+1-line_type)
      |Move.W  -> (pl,pc-1)
      |Move.NW -> (pl-1,pc-line_type)
      |Move.SW -> (pl+1,pc-line_type)


    method move_n p m =
      Move.move_n map p m



       
    (* [path_of_moves p moves] is the list of position obtain by successives 
     * applications of the move of [moves] from position [p] *)
    method path_of_moves p ml = match ml with
      | [] -> []
      | m :: q ->  let p' = self#move_n p m in
		   p'::self#path_of_moves p' q
    





    (* ******************** Pretty printing ************************* *)

    (*Permet de convertir une grille de booléens en grille de caractères*)
    method private char_grid_of_map () =
      let gc = Array.make_matrix (Array.length map) (Array.length map.(0)) ' ' in
      for l = 0 to Array.length map - 1 do
        for c = 0 to Array.length map.(0) - 1 do
          match map.(l).(c) with
          |Move.ICE n ->	gc.(l).(c) <- char_of_int (48 + n)
          |_ -> ()

        done
      done;
      for i = 0 to Array.length players - 1 do
        for j = 0 to players.(i)#nb_penguin - 1 do
          let (l,c) = players.(i)#get_penguin_pos j in
          gc.(l).(c) <- '#'
        done
      done;
      gc

    method pp_map f =
      Move.pp_grid f (self#char_grid_of_map ())

    method pp_grid f g =
      let gc = Array.make_matrix (Array.length map) (Array.length map.(0)) ' ' in
      for l = 0 to Array.length g - 1 do
        for c = 0 to Array.length g.(0) - 1 do
          match g.(l).(c) with
          |Move.ICE n ->	gc.(l).(c) <- char_of_int (48 + n)
          |_ -> ()

        done
      done;
      Move.pp_grid f gc




    method pp_path f path =
      let gc = self#char_grid_of_map () in
      let rec pp_path_tmp l i = match l with
        |[] -> ()
        |pos::q -> (*Printf.printf "(%d,%d)" (fst pos) (snd pos);*)
          gc.(fst pos).(snd pos) <- path_char i;
          pp_path_tmp q (i+1)
      in
      pp_path_tmp path 0;
      Move.pp_grid f gc

    (* *********************** Fin pretty_printing ******************** *)

    (*TODO verify penguins belongs to the player *)
    method legal_move_n p m =
      Move.legal_move_n map p m


    method private player_num_from_name pl_name =
      let found = ref false and i = ref 0  in
      while not !found && !i < Array.length players do
        if players.(!i)#get_name = pl_name then
          found := true
        else
          i := !i + 1
      done;
      if !i =  Array.length players then
        raise (Invalid_argument (pl_name ^ " n'est pas un nom de joueur"))
      else
        !i

    method move_player pl_name old_p m =
      let n = self#player_num_from_name pl_name  in
      let (legal,new_p,nb_t) = self#legal_move_n old_p m in
      if not legal then
        raise (Invalid_argument "Le mouvement n'est pas valide.")
      else
        (players.(n)#move old_p (self#move_n old_p m) nb_t;
         begin
         match map.(fst(old_p)).(snd(old_p)) with
         | TELEPORT(somewhere, true) -> (map.(fst old_p).(snd old_p) <- TELEPORT(somewhere, false))
         | _ -> (map.(fst old_p).(snd old_p) <- Move.WATER)
         end;
         begin
         match map.(fst new_p).(snd new_p) with
         | TELEPORT(somewhere, false) -> (map.(fst new_p).(snd new_p)<-TELEPORT(somewhere, true))
         | ICE v -> (players.(n)#add_score v;map.(fst new_p).(snd new_p) <- Move.PENGUIN)
         | _-> (map.(fst new_p).(snd new_p) <- Move.PENGUIN)
         end
        )

    method move_player_cpu pl_name =
      let n = self#player_num_from_name pl_name  in
      let pl = players.(n) in
      let (old_p,new_p) = players.(n)#cpu_move map in
      players.(n)#move old_p new_p 0; (* les robots ne font pas de challenge *)
      begin
      match map.(fst(old_p)).(snd(old_p)) with
      | TELEPORT(somewhere, true) -> (map.(fst old_p).(snd old_p) <- TELEPORT(somewhere, false))
      | _ -> (map.(fst old_p).(snd old_p) <- Move.WATER)
      end;
      begin
      match map.(fst new_p).(snd new_p) with
      | TELEPORT(somewhere, false) -> (map.(fst new_p).(snd new_p)<-TELEPORT(somewhere, true))
      | ICE v -> (players.(n)#add_score v;map.(fst new_p).(snd new_p) <- Move.PENGUIN)
      | _-> (map.(fst new_p).(snd new_p) <- Move.PENGUIN)
      end
        

  end


    (*

(* ********************** Test functions ************************* *)

let test_wrong_json _ =
  try
    open_map "test/wrong_json.json";
    assert_equal 0 1
  with
  |Failure _ -> ()

let test_wrong_json2 _ =
  try
    open_map "test/wrong_json2.json";
    assert_equal 0 1
  with
  |Failure _ -> ()

let test_parser _ =
  open_map "test/parse_test.json";
  assert_equal !turn 1;
  assert_equal !name "Niveau 1";
  assert_equal (Array.length !players) 4;
  assert_equal !players.(1)#get_name "42";
  assert_equal !players.(0)#get_pos (3,0);
  assert_equal !map.(1) [|PENGUIN;ICE 1;ICE 1;ICE 1;ICE 1;ICE 1;WATER;
				 WATER; ICE 1;ICE 1;ICE 1;ICE 1;ICE 1;PENGUIN|]

     *)
